User manual

Installation

Using Python wheel

TODO

Using APT

Hydrilla APT repository is hosted at https://hydrillarepos.koszko.org/apt/ and is signed with Wojtek's PGP key (fingerprint E9727060E3C5637C8A4F4B424BC5221C5A79FD1A). It is expected to work with modern releases of most APT-based distributions (including Debian bullseye and Trisquel nabia).

This APT repository can be used to install Hydrilla server and builder system-wide and to later update the installation. It has to be said that this also requires you to trust Wojtek's repository with your system's safety (a malicious APT repository could easily take over a system that uses it).

If you've decided you want to install the APT repository on your system, the easiest way to do so is by copy-pasting the following script into your POSIX shell (and then confirming with your password). You can of course modify it according to your needs.

__install_hydrilla_apt_repo() {
    local TMP="$1"
    local LISTS="$(cat <<EOF
deb     https://hydrillarepos.koszko.org/apt/ koszko main
deb-src https://hydrillarepos.koszko.org/apt/ koszko main
EOF
)"

    if ! wget -O "$TMP/koszko-keyring.gpg" https://hydrillarepos.koszko.org/apt/koszko-keyring.gpg; then
    echo "Error! Failed to download keyring file!" >&2
    return 1
    elif ! gpg --no-default-keyring --keyring "$TMP/koszko-keyring.gpg" --list-key E9727060E3C5637C8A4F4B424BC5221C5A79FD1A; then
    echo "Error! Invalid keyring file! Someone might be doing something nasty!" >&2
    return 1
    elif ! sudo cp "$TMP/koszko-keyring.gpg" /etc/apt/trusted.gpg.d/; then
    echo "Error!" >&2
    return 1
    elif ! printf %s "$LISTS" | sudo tee /etc/apt/sources.list.d/hydrillarepos.list > /dev/null; then
    echo "Error!" >&2
    return 1
    fi

    sudo apt-get update
}

install_hydrilla_apt_repo() {
    local TMP="$(mktemp -d)"
    __install_hydrilla_apt_repo "$TMP"
    local RESULT="$?"

    rm -r "$TMP"

    return "$RESULT"
}

install_hydrilla_apt_repo

This snippet is idempotent (i.e. it can be run multiple times and the effect will be as if it was run once). In addition, it executes apt-get update command at the end so that your APT is immediately aware of the new repository and its contents.

After installing the repository you can install Hydrilla builder and server using the following commands:

sudo apt install python3-hydrilla.builder
sudo apt install python3-hydrilla # this alone will also pull the builder as a dependency

The packages install their modules under /usr/lib/python3/dist-packages/ which is seen by Python3 interpreters installed from APT. The hydrilla and hydrilla-builder commands get placed in /usr/bin/.

In addition, the python3-hydrilla package also includes sample WSGI script and Apache2 config files for Hydrilla under /usr/share/doc/python3-hydrilla/examples/.

Understanding the concepts

TODO

Running

With development server

TODO

With Apache2

TODO